diff --git a/tests/nvme/003.out b/tests/nvme/003.out
index beb3561..01b2756 100644
--- a/tests/nvme/003.out
+++ b/tests/nvme/003.out
@@ -1,3 +1,2 @@
 Running nvme/003
-NQN:nqn.2014-08.org.nvmexpress.discovery disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/004.out b/tests/nvme/004.out
index 2559905..1a4e8e4 100644
--- a/tests/nvme/004.out
+++ b/tests/nvme/004.out
@@ -1,3 +1,2 @@
 Running nvme/004
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/008.out b/tests/nvme/008.out
index 62342e7..5661be6 100644
--- a/tests/nvme/008.out
+++ b/tests/nvme/008.out
@@ -1,3 +1,2 @@
 Running nvme/008
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/009.out b/tests/nvme/009.out
index 853663f..f379f7f 100644
--- a/tests/nvme/009.out
+++ b/tests/nvme/009.out
@@ -1,3 +1,2 @@
 Running nvme/009
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/010.out b/tests/nvme/010.out
index 90468f5..2241818 100644
--- a/tests/nvme/010.out
+++ b/tests/nvme/010.out
@@ -1,3 +1,2 @@
 Running nvme/010
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/011.out b/tests/nvme/011.out
index a780def..9822451 100644
--- a/tests/nvme/011.out
+++ b/tests/nvme/011.out
@@ -1,3 +1,2 @@
 Running nvme/011
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/012.out b/tests/nvme/012.out
index ec4bea8..1a0c53e 100644
--- a/tests/nvme/012.out
+++ b/tests/nvme/012.out
@@ -1,3 +1,2 @@
 Running nvme/012
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/013.out b/tests/nvme/013.out
index 10b78ec..ffa7625 100644
--- a/tests/nvme/013.out
+++ b/tests/nvme/013.out
@@ -1,3 +1,2 @@
 Running nvme/013
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/014.out b/tests/nvme/014.out
index c431864..5d1a517 100644
--- a/tests/nvme/014.out
+++ b/tests/nvme/014.out
@@ -1,4 +1,3 @@
 Running nvme/014
 NVMe Flush: success
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/015.out b/tests/nvme/015.out
index 829cf40..0c521bd 100644
--- a/tests/nvme/015.out
+++ b/tests/nvme/015.out
@@ -1,4 +1,3 @@
 Running nvme/015
 NVMe Flush: success
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/018.out b/tests/nvme/018.out
index 6b0e814..8e098d9 100644
--- a/tests/nvme/018.out
+++ b/tests/nvme/018.out
@@ -1,3 +1,2 @@
 Running nvme/018
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/019.out b/tests/nvme/019.out
index a52325f..9e98455 100644
--- a/tests/nvme/019.out
+++ b/tests/nvme/019.out
@@ -1,4 +1,3 @@
 Running nvme/019
 NVMe DSM: success
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/020.out b/tests/nvme/020.out
index 9e293ab..9e2e214 100644
--- a/tests/nvme/020.out
+++ b/tests/nvme/020.out
@@ -1,4 +1,3 @@
 Running nvme/020
 NVMe DSM: success
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/021 b/tests/nvme/021
index 7dc6a41..82a4634 100755
--- a/tests/nvme/021
+++ b/tests/nvme/021
@@ -33,7 +33,7 @@ test() {
 		echo "ERROR: device not listed"
 	fi
 
-	_nvme_disconnect_subsys "${def_subsysnqn}" >> "$FULL" 2>&1
+	_nvme_disconnect_subsys "${def_subsysnqn}"
 
 	_nvmet_target_cleanup
 
diff --git a/tests/nvme/022 b/tests/nvme/022
index c70fbba..adef181 100755
--- a/tests/nvme/022
+++ b/tests/nvme/022
@@ -33,7 +33,7 @@ test() {
 		echo "ERROR: reset failed"
 	fi
 
-	_nvme_disconnect_subsys "${def_subsysnqn}" >> "$FULL" 2>&1
+	_nvme_disconnect_subsys "${def_subsysnqn}"
 
 	_nvmet_target_cleanup
 
diff --git a/tests/nvme/023 b/tests/nvme/023
index 4e4d838..00ea3bc 100755
--- a/tests/nvme/023
+++ b/tests/nvme/023
@@ -33,7 +33,7 @@ test() {
 		echo "ERROR: smart-log bdev-ns failed"
 	fi
 
-	_nvme_disconnect_subsys "${def_subsysnqn}" >> "$FULL" 2>&1
+	_nvme_disconnect_subsys "${def_subsysnqn}"
 
 	_nvmet_target_cleanup
 
diff --git a/tests/nvme/024 b/tests/nvme/024
index 2535a9a..0c4fb6b 100755
--- a/tests/nvme/024
+++ b/tests/nvme/024
@@ -32,7 +32,7 @@ test() {
 	if ! nvme smart-log "/dev/${nvmedev}" -n 1 >> "$FULL" 2>&1; then
 		echo "ERROR: smart-log file-ns failed"
 	fi
-	_nvme_disconnect_subsys "${def_subsysnqn}" >> "$FULL" 2>&1
+	_nvme_disconnect_subsys "${def_subsysnqn}"
 
 	_nvmet_target_cleanup
 
diff --git a/tests/nvme/025 b/tests/nvme/025
index 46f6197..5b4fbf6 100755
--- a/tests/nvme/025
+++ b/tests/nvme/025
@@ -33,7 +33,7 @@ test() {
 		echo "ERROR: effects-log failed"
 	fi
 
-	_nvme_disconnect_subsys "${def_subsysnqn}" >> "$FULL" 2>&1
+	_nvme_disconnect_subsys "${def_subsysnqn}"
 
 	_nvmet_target_cleanup
 
diff --git a/tests/nvme/026 b/tests/nvme/026
index 5a7d992..9017ade 100755
--- a/tests/nvme/026
+++ b/tests/nvme/026
@@ -33,7 +33,7 @@ test() {
 		echo "ERROR: ns-desc failed"
 	fi
 
-	_nvme_disconnect_subsys "${def_subsysnqn}" >> "$FULL" 2>&1
+	_nvme_disconnect_subsys "${def_subsysnqn}"
 
 	_nvmet_target_cleanup
 
diff --git a/tests/nvme/027 b/tests/nvme/027
index 82b77a9..1a576a8 100755
--- a/tests/nvme/027
+++ b/tests/nvme/027
@@ -33,7 +33,7 @@ test() {
 		echo "ERROR: ns-rescan failed"
 	fi
 
-	_nvme_disconnect_subsys "${def_subsysnqn}" >> "$FULL" 2>&1
+	_nvme_disconnect_subsys "${def_subsysnqn}"
 
 	_nvmet_target_cleanup
 
diff --git a/tests/nvme/028 b/tests/nvme/028
index 0b49e20..874c1da 100755
--- a/tests/nvme/028
+++ b/tests/nvme/028
@@ -33,7 +33,7 @@ test() {
 		echo "ERROR: list-subsys"
 	fi
 
-	_nvme_disconnect_subsys "${def_subsysnqn}" >> "$FULL" 2>&1
+	_nvme_disconnect_subsys "${def_subsysnqn}"
 
 	_nvmet_target_cleanup
 
diff --git a/tests/nvme/029 b/tests/nvme/029
index caed0f7..7c68d7f 100755
--- a/tests/nvme/029
+++ b/tests/nvme/029
@@ -70,7 +70,7 @@ test() {
 	test_user_io "$dev" 511 1023 > "$FULL" 2>&1 || echo FAIL
 	test_user_io "$dev" 511 1025 > "$FULL" 2>&1 || echo FAIL
 
-	_nvme_disconnect_subsys "${def_subsysnqn}" >> "$FULL" 2>&1
+	_nvme_disconnect_subsys "${def_subsysnqn}"
 
 	_nvmet_target_cleanup
 
diff --git a/tests/nvme/031 b/tests/nvme/031
index ed5f196..a5c3808 100755
--- a/tests/nvme/031
+++ b/tests/nvme/031
@@ -44,7 +44,7 @@ test() {
 		_add_nvmet_subsys_to_port "${port}" "${subsys}$i"
 		_create_nvmet_host "${subsys}$i" "${def_hostnqn}"
 		_nvme_connect_subsys "${nvme_trtype}" "${subsys}$i"
-		_nvme_disconnect_subsys "${subsys}$i" >> "${FULL}" 2>&1
+		_nvme_disconnect_subsys "${subsys}$i"
 		_remove_nvmet_subsystem_from_port "${port}" "${subsys}$i"
 		_remove_nvmet_subsystem "${subsys}$i"
 		_remove_nvmet_host "${def_hostnqn}"
diff --git a/tests/nvme/033.out b/tests/nvme/033.out
index eb508be..9648c73 100644
--- a/tests/nvme/033.out
+++ b/tests/nvme/033.out
@@ -1,3 +1,2 @@
 Running nvme/033
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/034.out b/tests/nvme/034.out
index 0a7bd2f..5c851b4 100644
--- a/tests/nvme/034.out
+++ b/tests/nvme/034.out
@@ -1,3 +1,2 @@
 Running nvme/034
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/035.out b/tests/nvme/035.out
index a602713..455110c 100644
--- a/tests/nvme/035.out
+++ b/tests/nvme/035.out
@@ -1,3 +1,2 @@
 Running nvme/035
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/036.out b/tests/nvme/036.out
index d294f86..58676b1 100644
--- a/tests/nvme/036.out
+++ b/tests/nvme/036.out
@@ -1,3 +1,2 @@
 Running nvme/036
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/037 b/tests/nvme/037
index a2815b3..b1ebe1e 100755
--- a/tests/nvme/037
+++ b/tests/nvme/037
@@ -26,7 +26,7 @@ test_device() {
 		nsdev=$(_nvmet_passthru_target_connect "${nvme_trtype}" \
 				"${subsys}${i}")
 
-		_nvme_disconnect_subsys "${subsys}${i}" >>"${FULL}" 2>&1
+		_nvme_disconnect_subsys "${subsys}${i}"
 		_nvmet_passthru_target_cleanup "${subsys}${i}"
 	done
 
diff --git a/tests/nvme/041.out b/tests/nvme/041.out
index efee74c..1204173 100644
--- a/tests/nvme/041.out
+++ b/tests/nvme/041.out
@@ -1,6 +1,4 @@
 Running nvme/041
 Test unauthenticated connection (should fail)
-NQN:blktests-subsystem-1 disconnected 0 controller(s)
 Test authenticated connection
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/042.out b/tests/nvme/042.out
index 7d3d21a..1c3fc61 100644
--- a/tests/nvme/042.out
+++ b/tests/nvme/042.out
@@ -1,16 +1,9 @@
 Running nvme/042
 Testing hmac 0
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Testing hmac 1
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Testing hmac 2
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Testing hmac 3
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Testing key length 32
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Testing key length 48
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Testing key length 64
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/043.out b/tests/nvme/043.out
index 7419f91..f3f55a4 100644
--- a/tests/nvme/043.out
+++ b/tests/nvme/043.out
@@ -1,18 +1,10 @@
 Running nvme/043
 Testing hash hmac(sha256)
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Testing hash hmac(sha384)
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Testing hash hmac(sha512)
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Testing DH group ffdhe2048
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Testing DH group ffdhe3072
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Testing DH group ffdhe4096
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Testing DH group ffdhe6144
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Testing DH group ffdhe8192
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/044.out b/tests/nvme/044.out
index 53fdbe1..00bdcdb 100644
--- a/tests/nvme/044.out
+++ b/tests/nvme/044.out
@@ -1,10 +1,6 @@
 Running nvme/044
 Test host authentication
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test invalid ctrl authentication (should fail)
-NQN:blktests-subsystem-1 disconnected 0 controller(s)
 Test valid ctrl authentication
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test invalid ctrl key (should fail)
-NQN:blktests-subsystem-1 disconnected 0 controller(s)
 Test complete
diff --git a/tests/nvme/045.out b/tests/nvme/045.out
index 48f7e6b..565c563 100644
--- a/tests/nvme/045.out
+++ b/tests/nvme/045.out
@@ -8,5 +8,4 @@ Change DH group to ffdhe8192
 Re-authenticate with changed DH group
 Change hash to hmac(sha512)
 Re-authenticate with changed hash
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/047 b/tests/nvme/047
index 94d7d50..f5fb9f2 100755
--- a/tests/nvme/047
+++ b/tests/nvme/047
@@ -35,7 +35,7 @@ test() {
 	rand_io_size="$(_nvme_calc_rand_io_size 4M)"
 	_run_fio_rand_io --filename="/dev/${nvmedev}n1" --size="${rand_io_size}"
 
-	_nvme_disconnect_subsys "${def_subsysnqn}" >> "$FULL" 2>&1
+	_nvme_disconnect_subsys "${def_subsysnqn}"
 
 	_nvme_connect_subsys "${nvme_trtype}" "${def_subsysnqn}" \
 		--nr-write-queues 1 \
@@ -43,7 +43,7 @@ test() {
 
 	_run_fio_rand_io --filename="/dev/${nvmedev}n1" --size="${rand_io_size}"
 
-	_nvme_disconnect_subsys "${def_subsysnqn}" >> "$FULL" 2>&1
+	_nvme_disconnect_subsys "${def_subsysnqn}"
 
 	_nvmet_target_cleanup
 
diff --git a/tests/nvme/048.out b/tests/nvme/048.out
index 7f986ef..65ffa47 100644
--- a/tests/nvme/048.out
+++ b/tests/nvme/048.out
@@ -1,3 +1,2 @@
 Running nvme/048
-NQN:blktests-subsystem-1 disconnected 1 controller(s)
 Test complete
diff --git a/tests/nvme/rc b/tests/nvme/rc
index 4452274..7c6c303 100644
--- a/tests/nvme/rc
+++ b/tests/nvme/rc
@@ -430,7 +430,7 @@ _nvme_disconnect_ctrl() {
 _nvme_disconnect_subsys() {
 	local subsysnqn="$1"
 
-	nvme disconnect -n "${subsysnqn}"
+	nvme disconnect -n "${subsysnqn}" >> "$FULL" 2>&1
 }
 
 _nvme_connect_subsys() {